<?
	
	// Поддержка миниатюр и пользовательских меню
	if (function_exists('add_theme_support'))
		add_theme_support('post-thumbnails');
	if (function_exists('add_theme_support'))
		add_theme_support('menus');
	
	
	// Подключаем меню в админке
	require_once('admin_menu.php');
	
	
	// Блоки
	$blocks = get_option('template_block_options');
	foreach ($blocks as $i => $block) {
		$blocks[$i]['link'] = '/';
		if ($block['id'] != 'random')
			$blocks[$i]['link'] = get_category_link($block['id']);
	}
	
	$blocks['related']['id'] = my_category_id();
	
	
	// Слайдер
	$slider_ids = get_option('template_options');
	$slider_ids = explode(',', $slider_ids['slider']);
	
	$slider = $slider_ids;
	
	/*
	$slider = array();
	foreach ($slider_ids as $id) {
		$post = get_post($id);
		
		$slider[$id]['title'] = $post -> post_title;
		$slider[$id]['link'] = get_permalink($id);
		
		preg_match("/\<img.*src=\"(.*)\".*\>/Uis", $post -> post_content, $image);
		$slider[$id]['image'] = $image[1];
		
		$slider[$id]['excerpt'] = my_post_preview(100, $id);
	}
	*/
	
	
	// Сайдбары
	{sidebar_code}
	
	
	/*
		================================================================================
		Функции шаблона
		================================================================================
	*/
	
	
	// Вывод даты в текстовом формате
	function my_post_date_text($post_id = -1) {
		global $post;
		
		$months = array('января', 'февраля', 'марта', 'апреля', 'мая', 'июня', 'июля', 'августа', 'сентября', 'октября', 'ноября', 'декабря');
		
		$p = $post;
		if ($post_id > 0)
			$p = get_post($post_id);
		
		$date = $p->post_date;
		if (preg_match("/([0-9]+)-([0-9]+)-([0-9]+)[\r\n\t ]*([0-9]+):([0-9]+):([0-9]+)/i", $date, $date)) {
			$year = $date[1];
			$month = $date[2] - 1;
			$month = $months[$date[2] - 1];
			$day = $date[3];
			
			$date = "$day $month $year";
			return $date;
		}
		else
			return false;
	}
	
	
	// Вывод даты в числовом формате
	function my_post_date_numerical($post_id = -1) {
		global $post;
		
		$p = $post;
		if ($post_id > 0)
			$p = get_post($post_id);
		
		$date = $p->post_date;
		if (preg_match("/([0-9]+)-([0-9]+)-([0-9]+)[\r\n\t ]*([0-9]+):([0-9]+):([0-9]+)/i", $date, $date)) {
			$year = $date[1];
			$month = $date[2];
			if (strlen($month) == 1)
				$month = "0".$month;
			$day = $date[3];
			
			$date = "$day.$month.$year";
			return $date;
		}
		else
			return false;
	}
	
	
	// Название родительской рубрики поста
	function my_category_name() {
		global $category_name;
		
		foreach (get_categories() as $allcat)
			if ($allcat -> slug == $category_name) {
				$cat_name = $allcat -> cat_name;
				return $cat_name;
			}
		
		return false;
	}
	
	
	// ID родительской рубрики поста
	function my_category_id() {
		global $category_name;
		
		foreach (get_categories() as $allcat)
			if ($allcat -> slug == $category_name) {
				$cat_ID = $allcat -> cat_ID;
				return $cat_ID;
			}
		
		return false;
	}
	
	
	// Текстовое превью
	function my_post_preview($symb_count = 50, $post_id = -1) {
		global $post;
		
		$p = $post;
		if ($post_id > 0)
			$p = get_post($post_id);
		
		$content = $p -> post_content;
		$content = strip_tags($content);
		preg_match_all('/[\r\n\t ]*([^.?!]+[.?!]{1})/i', $content, $sent);
		$sent = implode(" ", $sent[1]);
		
		$res = '';
		
		$words = explode(" ", $sent);
		foreach ($words as $word) {
			if (mb_strlen(trim($res).' '.$word) > $symb_count)
				break;
			$res .= ' '.$word;
		}
		if (!preg_match("/[.?!]{1}\$/i", $res))
			$res .= '...';
		
		return trim($res);
	}
	
	
	// Миниатюра (картинка превью)
	function my_post_thumb($width, $height, $class = '', $post_id = -1) {
		global $post;
		
		$p = $post;
		if ($post_id > 0)
			$p = get_post($post_id);
		
		$attachments = get_posts(array('post_type' => 'attachment', 'numberposts' => -1, 'post_parent' => $p->ID));
		if ($attachments) {
			$src = wp_get_attachment_image_src($attachments[0]->ID);
			$src = $src[0];
			
			$src = str_replace(get_bloginfo('url'), '', $src);
			$src = preg_replace("/-[0-9]+x[0-9]+\.(jpg|jpeg|png|gif)/Uis", ".$1", $src);
			
			$src = get_stylesheet_directory_uri().'/thumbnail.php?src='.$src.'&w='.$width.'&h='.$height.'&zc=1';
			$title = my_post_title();
			
			return "<img src=\"$src\" alt=\"$title\" title=\"$title\" class=\"$class\" />";
		}
	}
	
	
	// Заголовок поста
	function my_post_title($length = 0, $post_id = -1) {
		global $post;
		
		$p = $post;
		if ($post_id > 0)
			$p = get_post($post_id);
		
		$title = $p->post_title;
		$res = $title;
		if ($length > 0 && mb_strlen($title) > $length)
			$res = mb_substr($title, 0, $length)."...";
		
		return trim($res);
	}
	
	
	// Категория поста
	function my_post_category() {
		global $post;
		
		ob_start();
		the_category(' &bull; ');
		$category = ob_get_clean();
		
		return $category;
	}
	
	
	// Автор поста
	function my_post_author() {
		global $post;
		
		$author = 'admin';
		
		return $author;
	}
	
	
	// Количество комментариев к посту
	function my_post_comments_number() {
		global $post;
		
		ob_start();
		comments_number('Комментариев нет', '1 комментарий','Комментарии (%)');
		$comments = ob_get_clean();
		
		return $comments;
	}
	
	
	// Рейтинги
	function my_post_rating() {
		global $post;
		
		ob_start();
		if (function_exists('the_ratings'))
			the_ratings();
		$rating = ob_get_clean();
		
		return $rating;
	}
	
	
	// Заголовок окна браузера
	function my_window_title() {
		return 'Default Title';
	}
	
	
	// Вывод блока
	function my_block($category, $template, $count = 5, $order = 'desc') {
		global $wpdb, $post;
		
		// Сохраняем исходный пост
		$post_src = $post;
		
		$posts = array();
		if ($category == 'random') {
			$posts = get_posts(array(
				'numberposts' => $count,
				'orderby' => 'rand'
			));
		}
		else {
			$posts = get_posts(array(
				'numberposts' => $count,
				'category' => $category,
				'orderby' => 'date',
				'order' => $order
			));
		}
		
		$result = '';
		foreach ($posts as $post) {
			setup_postdata($post);
			
			// Парсим шаблон
			$t = file_get_contents(get_stylesheet_directory().'/tpl/blocks/'.$template.'.tpl');
			
			// URL
			$t = str_replace('{link}', get_permalink(), $t);
			
			// Категория, автор, количество комментариев
			$t = str_replace('{category}', my_post_category(), $t);
			$t = str_replace('{author}', my_post_author(), $t);
			$t = str_replace('{comments_number}', get_comments_number(), $t);
			$t = str_replace('{comments}', my_post_comments_number(), $t);
			$t = str_replace('{rating}', my_post_rating(), $t);
			
			// Дата
			while (preg_match("/\{date\|(.*)\}/Uis", $t, $match)) {
				if ($match[1] == 'text')
					$t = str_replace($match[0], my_post_date_text(), $t);
				else
					$t = str_replace($match[0], my_post_date_numerical(), $t);
			}
			
			// Заголовок
			while (preg_match("/\{title\|(.*)\}/Uis", $t, $match)) {
				$t = str_replace($match[0], my_post_title($match[1]), $t);
			}
			
			// Текстовое превью
			while (preg_match("/\{excerpt\|(.*)\}/Uis", $t, $match)) {
				$t = str_replace($match[0], my_post_preview($match[1]), $t);
			}
			
			// Картинка
			while (preg_match("/\{thumbnail\|(.*)\|(.*)\|(.*)\}/Uis", $t, $match)) {
				$t = str_replace($match[0], my_post_thumb($match[1], $match[2], $match[3]), $t);
			}
			
			// Удаляем нераспознанные тэги
			$t = preg_replace("/\{.*\}/Uis", '', $t);
			
			$result .= $t;
		}
		
		// Восстанавливаем исходный пост
		$post = $post_src;
		setup_postdata($post);
		
		return $result;
	}
	
	
?>