<?php

/*
	Plugin Name: Импорт в Wordpress
	Plugin URI: 
	Description: Скрипт импорта в Wordpress
	Author: 
	Contributor: 
	Author URI: plugins.php
	Version: 8.0
*/


define('DEEP_LEVEL', 10); // Максимальная вложенность категорий

require_once('include/mfl.php');
require_once('include/curl.php');

require_once(ABSPATH.'wp-admin/includes/image.php');


function v7_add_menu() {
	add_options_page('Переимпорт в Wordpress', 'Переимпорт в Wordpress', 8, 'wordpress-reimporter', 'v7_re_options_page');
	add_options_page('Импорт в Wordpress', 'Импорт в Wordpress', 8, 'wordpress-importer', 'v7_options_page');
	add_options_page('Редактирование дат', 'Редактирование дат', 8, 'wordpress-dates', 'v7_dates_page');
}
add_action('admin_menu', 'v7_add_menu');


function v7_re_options_page() {
	global $wpdb;
	
	$src_dir = $_POST['src_dir'];
	$src_dir = mb_convert_encoding($src_dir, 'Windows-1251', 'UTF-8');
	
	$src_files = array();
	$src_dirs = array();
	
	if ($src_dir) {
		make_file_list($src_dir, $src_files);
		//make_dir_list($src_dir, $src_dirs);
	}
	
	if ($_POST['action'] == 'reimport') {
		$src_cat_id = $_POST['src_cat_id'];
		
		$posts_to_reimport = get_posts(array(
			'posts_per_page' => 100500,
			'category' => $src_cat_id,
			'orderby' => 'ID',
			'order' => 'asc'
		));
		
		if (count($posts_to_reimport) == count($src_files)) {
			foreach ($posts_to_reimport as $i => $post_to_reimport) {
				$src_file = $src_files[$i];
				$src_file = file_get_contents($src_file);
				$src_file = str_replace("\r", '', $src_file);
				$src_file = explode("\n", $src_file);
				
				$title = mb_convert_encoding($src_file[0], 'UTF-8', 'Windows-1251');
				
				$tags = mb_convert_encoding($src_file[2], 'UTF-8', 'Windows-1251');
				$tags = str_replace('tags:', '', $tags);
				$tags = str_replace(',', ', ', $tags);
				$tags = str_replace('  ', ' ', $tags);
				
				unset($src_file[0]);
				unset($src_file[1]);
				unset($src_file[2]);
				
				$content = implode("\r\n", $src_file);
				$content = mb_convert_encoding($content, 'UTF-8', 'Windows-1251');
				
				if ($title != $post_to_reimport->post_title) {
					echo "Пост {$post_to_reimport->ID}: не совпадают титлы: &laquo;{$title}&raquo; и &laquo;{$post_to_reimport->post_title}&raquo;<br/>";
				}
				
				$new_post = array(
					'ID' => $post_to_reimport->ID,
					'post_content' => $content,
					'tags_input' => $tags
				);
				wp_update_post($new_post);
				
				$description = strip_tags($content);
				preg_match_all('/[\r\n\t ]*([^.?!]+[.?!]{1})/i', $description, $description);
				$description = implode(' ', array_slice($description[1], 0, 3));
				update_post_meta($post_to_reimport->ID, 'description', $description);
			}
			
			echo '<b>Готово.</b><br/>';
		}
		else {
			echo '<b>Ошибка:</b> количество статей не совпадает.<br/>';
		}
	}
	
	?>
<div class="wrap">
	<h2>Параметры переимпорта</h2>
	<div class="meta-box-sortabless">
		<div class="postbox">
			<h3 style="padding: 8px 10px"><span>Настройки переимпорта</span></h3>
			<div class="inside">
				<form method="post" action="/wp-admin/options-general.php?page=wordpress-reimporter">
					<table class="form-table">
					<tbody>
						<tr valign="top">
							<th scope="row"><label for="src_dir">Папка со статьями:</label></th>
							<td><input type="text" id="src_dir" name="src_dir" size="100" /></td>
						</tr>
						<tr valign="top">
							<th scope="row"><label for="src_cat_id">ID категории статей:</label></th>
							<td><input type="text" id="src_cat_id" name="src_cat_id" size="100" value="4" /></td>
						</tr>
						<tr valign="top" style="display: none">
							<th scope="row"><label for="reimport">Способ:</label></th>
							<td>
								<select name="action">
									<option value="reimport">Переимпорт (только статьи)</option>
								</select>
							</td>
						</tr>
					</tbody>
					</table>
					
					<input style="margin: 8px 8px;" type="submit" value="&nbsp;Старт&nbsp;" />
				</form>
			</div>
		</div>
	</div>
</div>
	<?php
}


function v7_options_page() {
	global $wpdb;
	
	$src_dir = $_POST['src_dir'];
	$src_files = array();
	$src_dirs = array();
	
	if ($src_dir) {
		make_file_list($src_dir, $src_files);
		make_dir_list($src_dir, $src_dirs);
	}
	
	
	/* Чистый импорт */
	if ($_POST['action'] == 'import') {
		
		/* Начали */
		echo '<div class="wrap"><h2>Чистый импорт</h2>'; flush();
		
		
		/* Удаление категорий, медиафайлов, записей */
		echo '<b>Удаляем категории, метки, медиафайлы, записи...</b><br/>'; flush();
		
		$categories = get_categories(array('hide_empty' => false));
		foreach ($categories as $category) {
			wp_delete_term($category->term_id, 'category');
		}
		
		$tags = get_tags(array('hide_empty' => false));
		foreach ($tags as $tag) {
			wp_delete_term($tag->term_id, 'post_tag');
		}
		
		$attachments = get_posts(array('post_type' => 'attachment', 'numberposts' => -1));
		foreach ($attachments as $attachment) {
			wp_delete_attachment($attachment->ID, true);
		}
		
		$posts = get_posts(array('numberposts' => -1, 'post_status' => 'publish, future'));
		foreach ($posts as $post) {
			wp_delete_post($post->ID, true);
		}
		
		echo 'Готово.<br/>'; flush();
		
		
		/* Удаление меню */
		$menus = wp_get_nav_menus();
		foreach ($menus as $menu) {
			if ($menu->slug == 'category') {
				echo '<b>Удаляем меню `category`...</b><br/>'; flush();
				wp_delete_nav_menu($menu->term_id);
				echo 'Готово.<br/>'; flush();
				
				break;
			}
		}
		
		
		/* Оптимизация таблиц Wordpress */
		echo '<b>Оптимизируем таблицы Wordpress...</b><br/>'; flush();
		$wpdb->query('OPTIMIZE TABLE `wp_commentmeta`, `wp_comments`, `wp_postmeta`, `wp_posts`, `wp_terms`, `wp_term_relationships`, `wp_term_taxonomy`');
		echo 'Готово.<br/>'; flush();
		
		
		/* Подготовка к импорту категорий */
		$done_dirs = array();
		$done_menus = array();
		
		
		/* Импорт категорий  */
		for ($level = 1; $level <= DEEP_LEVEL; $level++) {
			foreach ($src_dirs as $src_path) {
				$src_path = str_replace($src_dir, '', $src_path);
				$src_path = preg_replace("|^/|Uis", '', $src_path);
				
				if (isset($done_dirs[$src_path]))
					continue;
				
				$src_path = explode('/', $src_path);
				if (count($src_path) == $level) {
					$parent = $src_path;
					unset($parent[count($src_path) - 1]);
					
					$parent = implode('/', $parent);
					$parent_id = $done_dirs[$parent];
					
					$cat_name = $src_path[count($src_path) - 1];
					$cat_slug = sanitize_title($cat_name);
					
					$cat_id = wp_insert_category(array('cat_name' => $cat_name, 'category_nicename' => $cat_slug, 'category_parent' => $parent_id));
					
					$src_path = implode('/', $src_path);
					$done_dirs[$src_path] = $cat_id;
				}
			}
		}
		
		
		/* Импорт меню */
		$menu = wp_create_nav_menu('category');
		if ($menu) {
			for ($level = 1; $level <= DEEP_LEVEL; $level++) {
				foreach ($src_dirs as $src_path) {
					$src_path = str_replace($src_dir, '', $src_path);
					$src_path = preg_replace("|^/|Uis", '', $src_path);
					
					if (isset($done_menus[$src_path]))
						continue;
					
					$src_path = explode('/', $src_path);
					if (count($src_path) == $level) {
						$parent = $src_path;
						unset($parent[count($src_path) - 1]);
						
						$parent = implode('/', $parent);
						
						$menu_item_name = $src_path[count($src_path) - 1];
						$menu_item_slug = sanitize_title($menu_item_name);
						
						$src_path = implode('/', $src_path);
						
						$menu_item_data =  array(
							'menu-item-object-id' => $done_dirs[$src_path],
							'menu-item-parent-id' => $done_menus[$parent],
							'menu-item-object' => 'category',
							'menu-item-type'      => 'taxonomy',
							'menu-item-status'    => 'publish'
						);
						
						$menu_item_id = wp_update_nav_menu_item($menu, 0, $menu_item_data);
						$done_menus[$src_path] = $menu_item_id;
					}
				}
			}
		}
		
		
		/* Подготовка к импорту записей */
		$posts = array();
		$images = array();
		
		foreach ($src_files as $src_filename) {
			$cat_name = str_replace($src_dir.'/', '', $src_filename);
			$cat_name = preg_replace("|\/[^\/]*\$|Uis", '', $cat_name);
			$cat_name = mb_convert_encoding($cat_name, 'UTF-8', 'Windows-1251');
			$cat_id = $done_dirs[$cat_name];
			
			$src_file = file_get_contents($src_filename);
			$src_file = str_replace("\r", '', $src_file);
			$src_file = explode("\n", $src_file);
			
			
			$title = mb_convert_encoding($src_file[0], 'UTF-8', 'Windows-1251');
			unset($src_file[0]);
			
			$image = $src_file[1];
			unset($src_file[1]);
			
			$tags = array();
			$custom = array();
			
			for ($j = 2; $j <= 3; $j++) {
				if (preg_match("/tags\:([^\r\n]*)/is", $src_file[$j], $tags_match)) {
					$tags = explode(',', $tags_match[1]);
					foreach ($tags as $i => $tag)
						$tags[$i] = mb_convert_encoding($tag, 'UTF-8', 'Windows-1251');
					
					unset($src_file[$j]);
				}
				
				if (preg_match("/custom\:([^\r\n]*)/is", $src_file[$j], $custom_match)) {
					preg_match_all("/([^,\=]+)\=([^,\=]+)/is", $custom_match[1], $custom_match);
					foreach ($custom_match[1] as $i => $key) {
						$key = mb_convert_encoding($key, 'UTF-8', 'Windows-1251');
						$value = mb_convert_encoding($custom_match[2][$i], 'UTF-8', 'Windows-1251');
						$custom[$key] = $value;
					}
					
					unset($src_file[$j]);
				}
			}
			
			$content = mb_convert_encoding(implode("\r\n", $src_file), 'UTF-8', 'Windows-1251');
			
			if (strlen($image) > 0)
				$images[] = $image;
			
			$posts[] = array('title' => $title, 'image' => $image, 'cat_id' => $cat_id, 'tags' => $tags, 'custom' => $custom, 'content' => $content);
		}
		
		
		/* Выкачиваем картинки */
		echo '<b>Выкачиваем картинки...</b><br/>'; flush();
		$images = get_urls($images);
		echo 'Готово.<br/>'; flush();
		
		/* Импортируем записи */
		echo '<b>Импортируем записи...</b><br/>'; flush();
		
		foreach ($posts as $post_data) {
			
			/* Добавляем пост */
			$post = array(
				'post_type' => 'post',
				'post_status' => 'publish',
				'post_title' => $post_data['title'],
				'post_content' => $post_data['content'],
				'post_author' => 1,
				'post_category' => array($post_data['cat_id']),
				'tags_input' => implode(', ', $post_data['tags'])
			);
			$post_id = wp_insert_post($post, $wp_error);
			
			
			/* Дополнительные поля */
			$custom = $post_data['custom'];
			foreach ($custom as $key => $value)
				update_post_meta($post_id, $key, $value);
			
			
			/* Description + Keywords */
			$description = strip_tags($post_data['content']);
			preg_match_all('/[\r\n\t ]*([^.?!]+[.?!]{1})/i', $description, $description);
			
			$description = implode(' ', array_slice($description[1], 0, 3));
			update_post_meta($post_id, 'description', $description);
			
			$keywords = implode(', ', $post_data['tags']);
			update_post_meta($post_id, 'keywords', $keywords);
			
			
			/* Сохраняем картинку, ЕСЛИ ОНА ЕСТЬ */
			if ($post_data['image']) {
				$upload_dir = wp_upload_dir();
				
				$wp_filetype = wp_check_filetype($post_data['image'], null);
				$filename = sanitize_title($post_data['title']).'.'.$wp_filetype['ext'];
				
				if(wp_mkdir_p($upload_dir['path']))
					$file = $upload_dir['path'].'/'.$filename;
				else
					$file = $upload_dir['basedir'].'/'.$filename;
				file_put_contents($file, $images[$post_data['image']]);
				
				
				/* Добавляем картинку */
				$attachment = array(
					'post_mime_type' => $wp_filetype['type'],
					'post_title' => $filename,
					'post_content' => '',
					'post_status' => 'inherit'
				);
				$attach_id = wp_insert_attachment($attachment, $file, $post_id);
				
				
				/* Проверяем картинку, связываем, если всё OK */
				$image_inserted = true;
				
				$attach_data = wp_generate_attachment_metadata($attach_id, $file);
				if ($attach_data['width'] + $attach_data['height'] == 0) {
					wp_delete_attachment($attach_id, true);
					@unlink($file);
					$image_inserted = false;
				}
				else {
					wp_update_attachment_metadata($attach_id, $attach_data);
					set_post_thumbnail($post_id, $attach_id);
				}
				
				/* Вставляем картинку в пост */
				/*
				if ($image_inserted) {
					$image_src = explode('wp-content', $file);
					
					wp_update_post(array(
						'ID' => $post_id,
						'post_content' => "<img src=\"/wp-content{$image_src[1]}\" width=\"300\" class=\"alignleft\" alt=\"{$post_data['title']}\" title=\"{$post_data['title']}\" />\r\n{$post_data['content']}"
					));
				}
				else {
					wp_update_post(array(
						'ID' => $post_id,
						'post_content' => "<!-- Картинка битая -->\r\n{$post_data['content']}"
					));
					
					echo "В записи `<a href=\"/wp-admin/post.php?post=$post_id&action=edit\" target=\"_blank\">{$post_data['title']}</a>` битая картинка.<br/>"; flush();
				};
				*/
			}
		}
		
		echo 'Готово.</div>';
	}
	
	?>
<div class="wrap">
	<h2>Параметры импорта</h2>
	<div class="meta-box-sortabless">
		<div class="postbox">
			<h3 style="padding: 8px 10px"><span>Настройки импорта</span></h3>
			<div class="inside">
				<form method="post" action="/wp-admin/options-general.php?page=wordpress-importer">
					<table class="form-table">
					<tbody>
						<tr valign="top">
							<th scope="row"><label for="src_dir">Папка с контентом:</label></th>
							<td><input type="text" id="src_dir" name="src_dir" size="100" /></td>
						</tr>
						<tr valign="top" style="display: none">
							<th scope="row"><label for="reimport">Способ:</label></th>
							<td>
								<select name="action">
									<option value="import">Чистый импорт</option>
								</select>
							</td>
						</tr>
					</tbody>
					</table>
					
					<input style="margin: 8px 8px;" type="submit" value="&nbsp;Старт&nbsp;" />
				</form>
			</div>
		</div>
	</div>
</div>
	<?php
}


function v7_dates_page() {
	
	if ($_GET['action'] == 'change') {
		echo '<div class="wrap"><h2>Работаем...</h2>'; flush();
		
		/* Сброс дат */
		/* echo '<b>Сброс дат...</b><br/>'; flush();
		
		$posts = get_posts(array('numberposts' => -1, 'post_status' => 'publish, future', 'order' => 'asc'));
		foreach ($posts as $post) {
			wp_update_post(array(
				'ID' => $post->ID,
				'post_date' => date("Y-m-d H:i:s"),
				'post_date_gmt' => date("Y-m-d H:i:s"),
				'post_status' => 'publish'
			));
		}
		
		echo 'Готово.<br/>'; */
		
		
		/* Распределяем даты */
		$order_future = array();
		$order_past = array();
		
		$order_catalog = array();
		
		foreach ($_POST['cat_id'] as $cat_id => $future_count) {
			
			/* Не планируем каталог */
			if ($future_count == '-') {
				continue;
				/* $posts_catalog = get_posts(array('numberposts' => -1, 'category' => $cat_id));
				foreach ($posts_catalog as $post)
					$order_catalog[$post->ID] = 1; */
			}
			
			$posts_future = get_posts(array('numberposts' => -1, 'category' => $cat_id));
			$posts_past = array_splice($posts_future, 0, count($posts_future) - (int)$future_count);
			
			foreach ($posts_future as $post)
				$order_future[] = $post->ID;
			
			foreach ($posts_past as $post)
				$order_past[] = $post->ID;
		}
		
		shuffle($order_future);
		shuffle($order_past);
		
		$date_startpoint = (int)microtime(1);
		$plan_future = $_POST['plan']['future'] * 30 * 24 * 3600;
		$plan_past = $_POST['plan']['past'] * 30 * 24 * 3600;
		$step_future = @(int)($plan_future / count($order_future));
		$step_past = @(int)($plan_past / count($order_past));
		
		/* Правим даты в прошлом */
		echo '<b>Правим даты в прошлом...</b><br/>'; flush();
		
		foreach ($order_past as $i => $post_id) {
			$date = $date_startpoint - $plan_past + $i * $step_past;
			
			if ($order_catalog[$post_id])
				$date = $date_startpoint - 3600 * 24 * 365;
			
			wp_update_post(array(
				'ID' => $post_id,
				'post_date' => date("Y-m-d H:i:s", $date),
				'post_date_gmt' => date("Y-m-d H:i:s", $date),
				'post_status' => 'publish'
			));
		}
		
		echo 'Готово.<br/>';
		
		
		/* Правим даты в будущем */
		echo '<b>Правим даты в будущем...</b><br/>'; flush();
		
		foreach ($order_future as $i => $post_id) {
			$date = $date_startpoint + $i * $step_future;
			
			wp_update_post(array(
				'ID' => $post_id,
				'post_date' => date("Y-m-d H:i:s", $date),
				'post_date_gmt' => date("Y-m-d H:i:s", $date),
				'post_status' => 'future'
			));
		}
		
		echo 'Готово.</div>';
	}
	
	?>
<div class="wrap">
	<h2>Редактирование дат</h2>
	<div class="meta-box-sortabless">
		<form method="post" action="/wp-admin/options-general.php?page=wordpress-dates&action=change">
			<div class="postbox">
				<h3 style="padding: 8px 10px">Параметры планирования</h3>
				<div class="inside">
					<table class="form-table">
					<tbody>
						<tr valign="top">
							<td>В прошлом: на <input type="text" name="plan[past]" size="2" value="3" /> месяцев</td>
							<td>В будущем: на <input type="text" name="plan[future]" size="2" value="3" /> месяцев</td>
						</tr>
					</tbody>
					</table>
				</div>
			</div>
			
			<div class="postbox">
				<h3 style="padding: 8px 10px"><span id="doState">Запланировать записи</span></h3>
				<div class="inside">
					<table class="form-table">
					<tbody>
						<?php   ?>
						<?php
							
							/* Вычисляем, к каким категориям относятся посты */
							$categories = array();
							
							$posts = get_posts(array('numberposts' => -1, 'post_status' => 'publish, future'));
							foreach ($posts as $post) {
								$category = wp_get_post_categories($post->ID);
								$category = get_categories(array('include' => $category[0], 'hide_empty' => false));
								$category = $category[0];
								
								if ($post->post_status == 'publish')
									$categories[$category->cat_ID][$category->cat_name]['publish']++;
								else if ($post->post_status == 'future')
									$categories[$category->cat_ID][$category->cat_name]['future']++;
							}
							
							$cat_id = array();
							$cat_name = array();
							$post_publish = array();
							$post_future = array();
							
							$js = array();
							$js_cat_count = 0;
							
							$i = 0;
							foreach ($categories as $id => $arr_id) {
								$cat_id[$i] = $id;
								foreach ($arr_id as $name => $arr_name) {
									$cat_name[$i] = $name;
									foreach ($arr_name as $status => $value) {
										if ($status == 'publish')
											$post_publish[$i] = $value;
										if ($status == 'future')
											$post_future[$i] = $value;
										
										$js_cat_count += $value * (int)($status == 'publish') + $value * (int)($status == 'future');
									}
								}
								
								$js[] = "parseInt('0' + document.getElementById('cat_id[$id]').value)";
								$i++;
							}
							
							$js = implode(' + ', $js);
							
						?>
						<?php foreach ($cat_id as $i => $id) : ?>
							<tr valign="top">
								<th scope="row"><label for="cat_id[<?php echo $id; ?>]"><a href="/wp-admin/edit.php?s&post_status=all&post_type=post&cat=<?php echo $id; ?>" title="Редактировать записи в категории `<?php echo $cat_name[$i]; ?>`" target="_blank"><?php echo $cat_name[$i]; ?></a></label></th>
								<td>Запланировать <input type="text" id="cat_id[<?php echo $id; ?>]" name="cat_id[<?php echo $id; ?>]" size="2" value="<?php echo (int)$post_future[$i]; ?>" onChange="doCalc()" onFocus="doCalc()" onBlur="doCalc()" /> записей из <b><?php echo (int)$post_publish[$i] + (int)$post_future[$i]; ?></b></td>
							</tr>
						<?php endforeach; ?>
					</tbody>
					</table>
					
					<script>
					function doCalc() {
						var future = <?php echo $js; ?>;
						var all = <?php echo $js_cat_count; ?>;
						var percent = parseInt(100 * future / all);
						document.getElementById('doState').innerHTML = 'Запланировать записи (' + percent + '%)';
					}
					</script>
				</div>
			</div>
			
			<input style="margin: 8px 8px;" type="submit" value="&nbsp;Старт&nbsp;" />
		</form>
	</div>
</div>
	<?php
}