<?php
	
	
	function get_url($url, $options = array(), $timeout = 30) {
		$c = curl_init($url);
		curl_setopt($c, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($c, CURLOPT_HEADER, $options['header']);
		
		curl_setopt($c, CURLOPT_CONNECTTIMEOUT, $timeout);
		curl_setopt($c, CURLOPT_TIMEOUT, $timeout);
		
		if (isset($options['ssl'])) {
			curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 0);
			curl_setopt($c, CURLOPT_SSL_VERIFYHOST, 0);
			curl_setopt($c, CURLOPT_HTTPHEADER, array('Expect:'));
		}
		
		if (isset($options['post_data'])) {
			curl_setopt($c, CURLOPT_POST, 1);
			curl_setopt($c, CURLOPT_POSTFIELDS, $options['post_data']);
		}
		
		if (isset($options['cookie']))
			curl_setopt($c, CURLOPT_COOKIE, $options['cookie']);
		
		if (isset($options['referer']))
			curl_setopt($c, CURLOPT_REFERER, $options['referer']);
		
		if (!isset($options['useragent']))
			$options['useragent'] = 'Opera/9.80 (Windows NT 6.1; WOW64; U; ru) Presto/2.10.229 Version/11.62';
		curl_setopt($c, CURLOPT_USERAGENT, $options['useragent']);
		
		$res = curl_exec($c);
		
		if (isset($options['charset']))
			$res = mb_convert_encoding($res, "UTF-8", $options['charset']);
		else
			$res = $res;
		
		curl_close($c);
		
		//if (!$options['no_cache'] && strlen($res) > 0)
		//if (!$options['no_cache'])
		//	@file_put_contents(_CACHE_DIR.'/get_url_'.md5($url), $res);
		
		//print_r($res);
		
		return $res;
	}
	
	function get_urls($urls, $options = array(), $threads = 10, $timeout = 30) {
		$urls = (array)$urls;
		
		$tasks = array();
		$done = 0;
		
		while ($urls) {
			$urls_part = array_splice($urls, 0, $threads);
			foreach ($urls_part as $url) {
				$tasks[$url] = get_url($url, $options, $timeout);
				$done++;
			}
			
			echo $done.'... '; flush();
		}
		
		echo '<br/>'; flush();
		
		return $tasks;
	}
	
	function _get_urls($urls, $options = array(), $threads = 10, $timeout = 30) {
		
		$mc = curl_multi_init();
		
		$tasks = array();
		$threads_left = $threads;
		
		while ($urls && ($threads_left > 0)) {
			$url = array_splice($urls, 0, 1);
			$url = $url[0];
			
			if (!$url)
				continue;
			
			$c = curl_init($url);
			curl_setopt($c, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($c, CURLOPT_HEADER, $options['header']);
			
			if (isset($options['ssl'])) {
				curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 0);
				curl_setopt($c, CURLOPT_SSL_VERIFYHOST, 0);
				curl_setopt($c, CURLOPT_HTTPHEADER, array('Expect:'));
			}
			
			if (isset($options['cookie']))
				curl_setopt($c, CURLOPT_COOKIE, $options['cookie']);
			
			if (isset($options['referer']))
				curl_setopt($c, CURLOPT_REFERER, $options['referer']);
			
			if (!isset($options['useragent']))
				$options['useragent'] = 'Opera/9.80 (Windows NT 6.1; WOW64; U; ru) Presto/2.10.229 Version/11.62';
			curl_setopt($c, CURLOPT_USERAGENT, $options['useragent']);
			
			curl_setopt($c, CURLOPT_CONNECTTIMEOUT, $timeout);
			curl_setopt($c, CURLOPT_TIMEOUT, $timeout);
			
			$tasks[$url] = $c;
			curl_multi_add_handle($mc, $c);
			
			$threads_left--;
		}
		//	echo 112; flush();
		$active = null;
		do {
			$mrc = curl_multi_exec($mc, $active);
		}
		while ($mrc == CURLM_CALL_MULTI_PERFORM);
		
		while ($active && ($mrc == CURLM_OK)) {
			if (curl_multi_select($mc) != -1) {
				do {
					$mrc = curl_multi_exec($mc, $active);
					$info = curl_multi_info_read($mc);
					if ($info['msg'] == CURLMSG_DONE) {
						$c = $info['handle'];
						$url = array_search($c, $tasks);
						//echo 221; flush();
						//unset($tasks[$url]);
						if (isset($options['charset']))
							$tasks[$url] = mb_convert_encoding(curl_multi_getcontent($c), "UTF-8", $options['charset']);
						else
							$tasks[$url] = curl_multi_getcontent($c);
						
						//if (!$options['no_cache'] && strlen($tasks[$url]) > 0)
						//if (!$options['no_cache'])
						//	@file_put_contents(_CACHE_DIR.'/'.md5($url), $tasks[$url]);
						
						curl_multi_remove_handle($mc, $c);
						curl_close($c);
						//print_r($tasks); exit;
						if ($url = array_splice($urls, 0, 1)) {
							$url = $url[0];
							
							$c = curl_init($url);
							curl_setopt($c, CURLOPT_FOLLOWLOCATION, 1);
							curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
							curl_setopt($c, CURLOPT_HEADER, $options['header']);
							
							if (isset($options['ssl'])) {
								curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 0);
								curl_setopt($c, CURLOPT_SSL_VERIFYHOST, 0);
								curl_setopt($c, CURLOPT_HTTPHEADER, array('Expect:'));
							}
							
							if (isset($options['cookie']))
								curl_setopt($c, CURLOPT_COOKIE, $options['cookie']);
							
							if (isset($options['referer']))
								curl_setopt($c, CURLOPT_REFERER, $options['referer']);
							
							if (!isset($options['useragent']))
								$options['useragent'] = 'Opera/9.80 (Windows NT 6.1; WOW64; U; ru) Presto/2.10.229 Version/11.62';
							curl_setopt($c, CURLOPT_USERAGENT, $options['useragent']);
							
							curl_setopt($c, CURLOPT_CONNECTTIMEOUT, $timeout);
							curl_setopt($c, CURLOPT_TIMEOUT, $timeout);
							
							//unset($tasks[$url]);
							$tasks[$url] = $c;
							
							curl_multi_add_handle($mc, $c);
						}
					}
				}
				while ($mrc == CURLM_CALL_MULTI_PERFORM);
			}
		}
		curl_multi_close($mc);
		
		return $tasks;
	}
	
	
?>