<?php

/*
	Plugin Name: Адаптация шаблона Wordpress
	Plugin URI: 
	Description: Скрипт адаптации шаблона Wordpress
	Author: 
	Contributor: 
	Author URI: plugins.php
	Version: 7.1
*/


require_once('include/mfl.php');


global $plugin_path;
$plugin_path = preg_replace("|[\/\\\\]theme\.php|Uis", '', __FILE__);


// Меню в админке
function v7_add_menu2() {
	add_options_page('Адаптация шаблона', 'Адаптация шаблона', 9, 'wordpress-theme-adapt', 'v7_theme_page');
}
add_action('admin_menu', 'v7_add_menu2');

function v7_theme_page() {
global $plugin_path;

?>
<div class="wrap">
	<div class="meta-box-sortabless">
		<h2>Адаптация шаблона</h2>
		<?php
			if ($_GET['action'] == 'update' && count($_POST) > 0) {
				$_POST['src'] = stripslashes($_POST['src']);
				$_POST['dest'] = stripslashes($_POST['dest']);
				
				update_option('theme_adapt_options', $_POST);
				echo '<div class="updated"><p>Настройки обновлены</p></div>';
			}
			$theme_adapt_options = get_option('theme_adapt_options');
		?>
		
		<form method="post" action="/wp-admin/options-general.php?page=wordpress-theme-adapt&action=update">
			<div class="postbox">
				<h3 style="padding: 8px 10px">Настройки</h3>
				<div class="inside">
					<table class="form-table">
					<tbody>
						<tr valign="top">
							<td>Исходный путь: <input type="text" name="src" size="100" value="<?php echo $theme_adapt_options['src']; ?>" /></td>
							<td>Конечный путь: <input type="text" name="dest" size="100" value="<?php echo $_SERVER['DOCUMENT_ROOT']; ?>/wp-content/themes/default" readonly /></td>
						</tr>
						<tr valign="top">
							<td colspan="2"><input type="checkbox" name="on" <?php if ($theme_adapt_options['on']) echo 'checked'; ?> /> Включить</td>
						</tr>
					</tbody>
					</table>
				</div>
			</div>
			<input style="margin: 8px 8px;" type="submit" value="&nbsp;Старт&nbsp;" />
		</form>
		
		<br/>
		
		<h2>Бэкапы</h2>
		<?php
			if ($_GET['action'] == 'backup' && count($_POST) > 0) {
				$backup = $_POST['backup'];
				
				@delete_directory($theme_adapt_options['src']);
				@mkdir($theme_adapt_options['src'], 777, true);
				@copy_directory($plugin_path.'/backup/'.$backup, $theme_adapt_options['src']);
				
				echo '<div class="updated"><p>Бэкап восстановлен</p></div>';
			}
			$theme_adapt_options = get_option('theme_adapt_options');
		?>
		<form method="post" action="/wp-admin/options-general.php?page=wordpress-theme-adapt&action=backup">
			<div class="postbox">
				<h3 style="padding: 8px 10px">Отменить изменения</h3>
				<div class="inside">
					<table class="form-table">
					<tbody>
						<tr valign="top">
							<td>
								Бэкап:
								<select name="backup" style="width: 140px">
								<?php
									make_dir_list($plugin_path.'/backup', $backups, 1);
									foreach ((array)$backups as $backup) : ?>
									<option><?php $backup = explode('/', $backup); echo $backup[count($backup) - 1]; ?></option>
								<?php endforeach; ?>
								</select>
							</td>
						</tr>
					</tbody>
					</table>
				</div>
			</div>
			<input style="margin: 8px 8px;" type="submit" value="&nbsp;Старт&nbsp;" />
		</form>
	</div>
</div>
	<?php
}


// Обработка шаблона
function adapt_theme() {
	global $plugin_path;
	
	$theme_adapt_options = get_option('theme_adapt_options');
	
	if (is_feed() || is_admin())
		return;
	
	if (!$theme_adapt_options['on'])
		return;
	
	// Делаем бэкап
	$backup = date("d.m.Y H-i-s", time());
	@mkdir($plugin_path.'/backup/'.$backup, 0777, true);
	@copy_directory($theme_adapt_options['src'], $plugin_path.'/backup/'.$backup);
	
	// Удаляем текущий шаблон и парсим новый
	@delete_directory($theme_adapt_options['dest']);
	@mkdir($theme_adapt_options['dest']);
	@parse_template($theme_adapt_options['src'], $theme_adapt_options['dest']);
}
add_action('init', 'adapt_theme');


// Парсинг шаблона
function parse_template($src, $dest) {
	global $plugin_path;
	
	$_POST['src_dir'] = $src;
	$_POST['dest_dir'] = $dest;
	
	$home = file_get_contents($_POST['src_dir'].'/home.html');
	$archive = file_get_contents($_POST['src_dir'].'/archive.html');
	$single = file_get_contents($_POST['src_dir'].'/single.html');
	
	
	/* Выделяем сайдбары */
	$sidebar_code = array();
	
	while (preg_match("|\[widget\|(.+)\](.+)\[\/widget\]|Uis", $home, $widget) || preg_match("|\[widget\|(.+)\](.+)\[\/widget\]|Uis", $archive, $widget) || preg_match("|\[widget\|(.+)\](.+)\[\/widget\]|Uis", $single, $widget)) {
		$home = str_replace($widget[0], "<?php if (!function_exists('dynamic_sidebar') || !dynamic_sidebar('{$widget[1]}')) : ?><?php endif; ?>", $home);
		$archive = str_replace($widget[0], "<?php if (!function_exists('dynamic_sidebar') || !dynamic_sidebar('{$widget[1]}')) : ?><?php endif; ?>", $archive);
		$single = str_replace($widget[0], "<?php if (!function_exists('dynamic_sidebar') || !dynamic_sidebar('{$widget[1]}')) : ?><?php endif; ?>", $single);
		
		$match = preg_replace("/\{.*\}/Uis", '{~}', $widget[2]);
		$match = preg_replace("/[\r\n\t]+/Uis", '', $match);
		$match = explode('{~}', $match);
		
		$sidebar_code[$widget[1]] = "if (function_exists('register_sidebar'))
			register_sidebar(array('name' => '{$widget[1]}',
			'description' => '{$widget[1]} description',
			'before_widget' => '".trim($match[0])."',
			'after_widget' => '".trim($match[2])."',
			'before_title' => '',
			'after_title' => '".trim($match[1])."'
		));";
	}
	
	
	// Выделяем блоки
	$block_code = array();
	
	// Обрабатываем Related как обычный блок
	$single = str_replace('[related]', '[block|related|4]', $single);
	$single = str_replace('[/related]', '[/block]', $single);
	
	while (preg_match("|\[block\|(.+)\|(.+)\](.+)\[\/block\]|Uis", $home, $block) || preg_match("|\[block\|(.+)\|(.+)\](.+)\[\/block\]|Uis", $archive, $block) || preg_match("|\[block\|(.+)\|(.+)\](.+)\[\/block\]|Uis", $single, $block)) {
		
		preg_match("/\[item\](.*)\[\/item\]/Uis", $block[3], $item);
		$block_code[$block[1]] = $item[1];
		
		$block_new = $block[3];
		$block_new = str_replace('{block}', "<?php echo \$blocks['{$block[1]}']['title']; ?>", $block_new);
		$block_new = str_replace($item[0], "<?php echo my_block(\$blocks['{$block[1]}']['id'], '{$block[1]}', {$block[2]}); ?>", $block_new);
		$block_new = str_replace('{link}', "<?php echo \$blocks['{$block[1]}']['link']; ?>", $block_new);
		
		$home = str_replace($block[0], $block_new, $home);
		$archive = str_replace($block[0], $block_new, $archive);
		$single = str_replace($block[0], $block_new, $single);
	}
	
	
	/* Листинг и внутряк */
	while (preg_match("|\[archive](.+)\[\/archive\]|Uis", $archive, $block) || preg_match("|\[single](.+)\[\/single\]|Uis", $single, $block)) {
		
		$block_new = $block[1];
		
		$block_new = preg_replace("/\{link\}/Uis", "<?php the_permalink(); ?>", $block_new);
		
		$block_new = preg_replace("/\{category\}/Uis", "<?php echo my_post_category(); ?>", $block_new);
		$block_new = preg_replace("/\{author\}/Uis", "<?php echo my_post_author(); ?>", $block_new);
		$block_new = preg_replace("/\{comments_number\}/Uis", "<?php echo get_comments_number(); ?>", $block_new);
		$block_new = preg_replace("/\{comments\}/Uis", "<?php echo my_post_comments_number(); ?>", $block_new);
		$block_new = preg_replace("/\{rating\}/Uis", "<?php echo my_post_rating(); ?>", $block_new);
		
		while (preg_match("/\{date\|(.*)\}/Uis", $block_new, $match)) {
			if ($match[1] == 'text')
				$block_new = str_replace($match[0], "<?php echo my_post_date_text(); ?>", $block_new);
			else
				$block_new = str_replace($match[0], "<?php echo my_post_date_numerical(); ?>", $block_new);
		}
		
		$block_new = preg_replace("/\{title\|(.*)\}/Uis", "<?php echo my_post_title($1); ?>", $block_new);
		$block_new = preg_replace("/\{excerpt\|(.*)\}/Uis", "<?php echo my_post_preview($1); ?>", $block_new);
		
		$block_new = preg_replace("/\{content}/Uis", "<?php the_content(''); ?>", $block_new);
		
		$block_new = preg_replace("/\{thumbnail\|(.*)\|(.*)\|(.*)\}/Uis", "<?php echo my_post_thumb($1, $2, '$3'); ?>", $block_new);
		
		// Заменяем
		$archive = str_replace('{category_title}', "<?php echo my_category_name(); ?>", $archive);
		$archive = str_replace('{page_navi}', "<?php if(function_exists('wp_page_numbers')) : wp_page_numbers(); endif; ?>", $archive);
		
		$block_new = '<?php query_posts($query_string."&orderby=date&order=desc"); while (have_posts()) : the_post(); ?>'.$block_new.'<?php endwhile; ?>';
		$archive = str_replace($block[0], $block_new, $archive);
		$single = str_replace($block[0], $block_new, $single);
	}
	
	
	// Навигация
	$home = str_replace('{categories}', '{nav|categories}', $home);
	$archive = str_replace('{categories}', '{nav|categories}', $archive);
	$single = str_replace('{categories}', '{nav|categories}', $single);
	
	$home = preg_replace("/\{nav\|(.*)\}/Uis", "<?php wp_nav_menu(array('menu' => '$1', 'container' => '', 'items_wrap' => '%3\$s')); ?>", $home);
	$archive = preg_replace("/\{nav\|(.*)\}/Uis", "<?php wp_nav_menu(array('menu' => '$1', 'container' => '', 'items_wrap' => '%3\$s')); ?>", $archive);
	$single = preg_replace("/\{nav\|(.*)\}/Uis", "<?php wp_nav_menu(array('menu' => '$1', 'container' => '', 'items_wrap' => '%3\$s')); ?>", $single);
	
	
	// Комментарии
	while (preg_match("/\[comments\](.*(\[item\](.*)\[\/item\]).*)\[\/comments\]/Uis", $single, $comments)) {
		$single = str_replace('[comments]', "<?php if (comments_open() && get_comments_number()) : ?>", $single);
		$single = str_replace('[/comments]', "<?php endif; ?>", $single);
		
		$single = str_replace('[item]', "<?php \$comments = get_comments('post_id='.\$post->ID.'&orderby=date&order=asc&status=approve'); foreach (\$comments as \$comment) : ?>", $single);
		$single = str_replace('[/item]', "<?php endforeach; ?>", $single);
		
		$item = $comments[3];
		
		$item = str_replace('{author}', '<?php echo $comment->comment_author; //comment_author_link(); ?>', $item);
		$item = str_replace('{date}', "<?php comment_date('d.m.Y', \$comment->comment_ID); ?>", $item);
		$item = str_replace('{content}', '<?php echo $comment->comment_content; ?>', $item);
		$item = preg_replace("/\{avatar\|(.*)\}/Uis", "<?php echo get_avatar(\$comment->comment_ID, $1); ?>", $item);
		
		$single = str_replace($comments[3], $item, $single);
	}
	
	$single = str_replace('{form}', '<?php comment_form(); ?>', $single);
	
	
	// Общие замены
	$home = str_replace('</head>', '<?php wp_head(); ?>
<link rel="stylesheet" href="<?php bloginfo("stylesheet_directory"); ?>/style.css" type="text/css" media="all">
</head>
', $home);
	$archive = str_replace('</head>', '<?php wp_head(); ?>
<link rel="stylesheet" href="<?php bloginfo("stylesheet_directory"); ?>/style.css" type="text/css" media="all">
</head>
', $archive);
	$single = str_replace('</head>', '<?php wp_head(); ?>
<link rel="stylesheet" href="<?php bloginfo("stylesheet_directory"); ?>/style.css" type="text/css" media="all">
</head>
', $single);
	
	$home = str_replace('</body>', '<?php wp_footer(); ?>
</body>', $home);
	$archive = str_replace('</body>', '<?php wp_footer(); ?>
</body>', $archive);
	$single = str_replace('</body>', '<?php wp_footer(); ?>
</body>', $single);
	
	$home = preg_replace("|\<[ ]?title[ ]?\>.*\<[ ]?\/[ ]?title[ ]?\>|Uis", '<title><?php echo my_window_title(); ?></title>', $home);
	$archive = preg_replace("|\<[ ]?title[ ]?\>.*\<[ ]?\/[ ]?title[ ]?\>|Uis", '<title><?php echo my_window_title(); ?></title>', $archive);
	$single = preg_replace("|\<[ ]?title[ ]?\>.*\<[ ]?\/[ ]?title[ ]?\>|Uis", '<title><?php echo my_window_title(); ?></title>', $single);
	
	// URLы стилей
	$home = str_replace('"images/', '"<?php bloginfo("stylesheet_directory"); ?>/images/', $home);
	$archive = str_replace('"images/', '"<?php bloginfo("stylesheet_directory"); ?>/images/', $archive);
	$single = str_replace('"images/', '"<?php bloginfo("stylesheet_directory"); ?>/images/', $single);
	
	//$home = preg_replace("|\<[a-z]+.*.com\/.*[^\?]{1}\>|U", '', $home);
	//$archive = preg_replace("|\<[a-z]+.*.com\/.*[^\?]{1}\>|U", '', $archive);
	//$single = preg_replace("|\<[a-z]+.*.com\/.*[^\?]{1}\>|U", '', $single);
	
	$home = str_replace('{copyright}', '&copy; 2012, <a href="/"><?php bloginfo("name"); ?></a> - <?php bloginfo("description"); ?>. Все права защищены.', $home);
	$archive = str_replace('{copyright}', '&copy; 2012, <a href="/"><?php bloginfo("name"); ?></a> - <?php bloginfo("description"); ?>. Все права защищены.', $archive);
	$single = str_replace('{copyright}', '&copy; 2012, <a href="/"><?php bloginfo("name"); ?></a> - <?php bloginfo("description"); ?>. Все права защищены.', $single);
	
	
	// Слайдер
	preg_match("/\[slider\](.*)\[\/slider\]/Uis", $home, $slider);
	$home = str_replace($slider[0], "<?php include('slider.php'); ?>", $home);
	$slider = $slider[1];
	
	
	// Сохраняем
	@copy_directory($plugin_path.'/default', $_POST['dest_dir']);
	@copy_directory($_POST['src_dir'], $_POST['dest_dir']);
	
	file_put_contents($_POST['dest_dir'].'/home.php', $home);
	file_put_contents($_POST['dest_dir'].'/archive.php', $archive);
	file_put_contents($_POST['dest_dir'].'/search.php', $archive);
	file_put_contents($_POST['dest_dir'].'/single.php', $single);
	
	@unlink($_POST['dest_dir'].'/home.html');
	@unlink($_POST['dest_dir'].'/archive.html');
	@unlink($_POST['dest_dir'].'/single.html');
	
	// Блоки
	$admin_menu_code = array();
	
	foreach ($block_code as $block => $code) {
		file_put_contents($_POST['dest_dir'].'/tpl/blocks/'.$block.'.tpl', $code);
		
		if ($block != 'related')
			$admin_menu_code[] = "<tr>
<td><input type=\"text\" name=\"".$block."[title]\" value=\"<? echo \$theme_options['$block']['title']; ?>\" /></td>
<td><input style=\"width: 120px;\" type=\"text\" name=\"".$block."[id]\" value=\"<? echo \$theme_options['$block']['id']; ?>\" /></td>
</tr>";
	}
	
	
	// Меню админки
	$admin_menu = file_get_contents($_POST['dest_dir'].'/admin_menu.php');
	$admin_menu = str_replace('{admin_menu}', implode("\r\n\r\n", $admin_menu_code), $admin_menu);
	file_put_contents($_POST['dest_dir'].'/admin_menu.php', $admin_menu);
	
	// Сайдбары
	$functions = file_get_contents($_POST['dest_dir'].'/functions.php');
	$functions = str_replace('{sidebar_code}', implode("\r\n\r\n", $sidebar_code), $functions);
	file_put_contents($_POST['dest_dir'].'/functions.php', $functions);
	
	
	// Слайдер
	file_put_contents($_POST['dest_dir'].'/slider.php', $slider);
	
}