<?php

// Подключаем меню темы в админке
function template_menu() {
	add_theme_page('Настройка блоков', 'Настройка блоков', 1, 'template_block_settings', 'template_block_options_page');
	add_theme_page('Коды баннеров', 'Коды баннеров', 2, 'template_settings', 'template_options_page');
	//add_theme_page('Комментарии ВКонтакте', 'Комментарии ВКонтакте', 3, 'template_vk_api', 'template_vk_api_page');
}
add_action('admin_menu', 'template_menu');


// Меню "Настройка блоков"
function template_block_options_page() {
	?>
	<div class="wrap">
		<h2>Настраиваемые блоки</h2>
		<?php
			if (count($_POST) > 0)
				update_option('template_block_options', $_POST);
			$theme_options = get_option('template_block_options');
		?>
		<style>
		.gr { tont-size: 12px; font-weight: normal; color: #888; }
		.matrix { margin: 5px 0 15px -8px; }
			.matrix td { padding: 1px 8px; }
		</style>
		<form method="post">
			<table border="0" cellspacing="0" cellpadding="0" class="matrix">
				<tr>
					<td><b>Название блока <br/> <span class="gr">(отображаемый заголовок)</span></b></td>
					<td><b>Категории статей <br/> <span class="gr">(перечисление ID через запятую)</span></b></td>
				</tr>
				
				<?php
					$blocks = array();
					$home =
						file_get_contents(get_stylesheet_directory().'/slider.php').
						file_get_contents(get_stylesheet_directory().'/include/pre.php').
						file_get_contents(get_stylesheet_directory().'/include/home.php').
						file_get_contents(get_stylesheet_directory().'/include/sidebar.php').
						file_get_contents(get_stylesheet_directory().'/include/post.php');
					
					//preg_match_all("/\\\$blocks\[\'(.*)\'\]/Uis", $home, $home);
					preg_match_all("/map_block\(\'(.+)\'/Uis", $home, $home);
					foreach ($home[1] as $block)
						$blocks[$block] = 1;
					
					foreach ($blocks as $block => $var) :
				?>
					<tr>
						<td><input style="width: 160px;" type="text" name="<?php echo $block; ?>[title]" value="<? echo $theme_options[$block]['title']; ?>" title="Блок #<? echo $block; ?>" /></td>
						<td><input style="width: 80px;" type="text" name="<?php echo $block; ?>[id]" value="<? echo $theme_options[$block]['id']; ?>" /></td>
					</tr>
				<?php endforeach; ?>
			</table>
			
			<input type="submit" value="Сохранить настройки"/>
		</form>
	</div>
	<?php
}


// Меню "Настройка баннеров"
function template_options_page() {
	?>
	<div class="wrap">
		<h2>Коды баннеров и счетчиков</h2>
		<?php
			if (count($_POST) > 0) {
				foreach ($_POST as $key => $value) {
					$_POST[$key] = stripslashes($value);
				}
				update_option('template_options', $_POST);
			}
			$theme_options = get_option('template_options');
		?>
		<style>
			.gr {
				font-size: 11px;
				color: #888;
			}
		</style>
		<form method="post">
			<?php
				$banners = array();
				$home =
					file_get_contents(get_stylesheet_directory().'/header.php').
					file_get_contents(get_stylesheet_directory().'/home.php').
					file_get_contents(get_stylesheet_directory().'/include/pre.php').
					file_get_contents(get_stylesheet_directory().'/include/home.php').
					file_get_contents(get_stylesheet_directory().'/include/sidebar.php').
					file_get_contents(get_stylesheet_directory().'/include/post.php').
					file_get_contents(get_stylesheet_directory().'/single.php').
					file_get_contents(get_stylesheet_directory().'/archive.php').
					file_get_contents(get_stylesheet_directory().'/sidebar.php').
					file_get_contents(get_stylesheet_directory().'/footer.php');
				
				preg_match_all("/map_banner\(\'(.+)\'(.*)\)/Uis", $home, $home);
				foreach ($home[1] as $i => $banner) {
					if ($banner == 'counters')
						continue;
					
					$size = $home[2][$i] ? preg_replace("/[^0-9]*([0-9]+x[0-9]+)[^0-9]*/is", "$1", $home[2][$i]) : '728x90';
					$banners[$banner] = $size;
				}
				
				foreach ($banners as $banner => $size) :
			?>
			<b>Код баннера &laquo;<?php echo $banner; ?>&raquo;<br/> <span class="gr">(размеры <?php echo $size; ?>):</span></b><br/>
			<textarea cols="80" name="<?php echo $banner; ?>" rows="5"><?php echo $theme_options[$banner]; ?></textarea><br/>
			<br/>
			<?php endforeach; ?>
			<br/>
			
			<b>Счётчики<br/> <span class="gr">(отображаются в подвале сайта):</span></b><br/>
			<textarea cols="80" name="counters" rows="5"><?php echo $theme_options['counters']; ?></textarea><br/>
			<br/>
			<br/>
			
			<input type="submit" value="Сохранить настройки"/><br/>
		</form>
	</div>
	<?php
}


// Меню "Комментарии ВКонтакте"
function template_vk_api_page() {
	?>
	<div class="wrap">
		<h2>Комментарии ВКонтакте</h2>
		<?php
			if (count($_POST) > 0) {
				update_option('template_vk_options', $_POST);
			}
			$template_vk_options = get_option('template_vk_options');
		?>
		<style>
			.gr {
				font-size: 11px;
				color: #888;
			}
		</style>
		<form method="post">
			<b>ID приложения &laquo;Комментарии&raquo;<br/> <span class="gr">(можно получить <a href="http://vk.com/developers.php?id=-1_27987570&s=1">здесь</a>):</span></b><br/>
			<input type="text" size="50" name="vk_api_id_comments" value="<?php echo $template_vk_options['vk_api_id_comments']; ?>" /><br/>
			<br/>
			
			<input type="submit" value="Сохранить настройки"/><br/>
		</form>
	</div>
	<?php
}

?>